## minizinc 2.0.8+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.7)

if (USE_STDLIBCPP)
  set(MZN_LIBCPP libstdc++)
else()
  set(MZN_LIBCPP libc++)
endif()

if(APPLE)
   SET(CMAKE_OSX_DEPLOYMENT_TARGET "10.7")
   set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++0x")
   set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "${MZN_LIBCPP}")
endif(APPLE)

project (libminizinc CXX)

# The version number.
set (libminizinc_VERSION_MAJOR 2)
set (libminizinc_VERSION_MINOR 0)
set (libminizinc_VERSION_PATCH 8)

if (ADDITIONAL_DATE_STRING)
  set (libminizinc_VERSION_PATCH "${libminizinc_VERSION_PATCH}.${ADDITIONAL_DATE_STRING}")
endif()

include(CheckCXXCompilerFlag)

SET(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
check_cxx_compiler_flag(-Werror HAS_WERROR)

if (HAS_WERROR)
  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
endif()

check_cxx_compiler_flag(-std=c++11 HAS_STDCPP11)
if (HAS_STDCPP11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
else()
  check_cxx_compiler_flag(-std=c++0x HAS_STDCPP0X)
  if (HAS_STDCPP0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
endif()

check_cxx_compiler_flag(-stdlib=${MZN_LIBCPP} HAS_STDLIBLIBCPP)

if (HAS_STDLIBLIBCPP)
  set(SAFE_CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=${MZN_LIBCPP}")
  check_cxx_source_compiles("int main(void) {return 0;}" LINKS_STDLIBLIBCPP)
  if (NOT LINKS_STDLIBLIBCPP)
    set(CMAKE_CXX_FLAGS "${SAFE_CMAKE_CXX_FLAGS}")
  endif()
endif()

check_cxx_source_compiles("#include <unordered_set>
int main(void) { std::unordered_set<int> x; return 0; }" HAS_CPP11)

if (NOT HAS_CPP11)
  check_cxx_source_compiles("#include <tr1/unordered_set>
                             int main(void) { std::tr1::unordered_set<int> x; return 0; }" HAS_CPP11_TR1)
  if (HAS_CPP11_TR1)
    set(MZN_NEED_TR1 1)
  else()
    message(FATAL_ERROR "A c++11 compatible C++ standard library is required to build libminizinc.")
  endif()
endif()
   
CHECK_CXX_SOURCE_COMPILES("int main(void) { static __thread int x; (void)x; return 0;}" HAS_ATTR_THREAD)

if (NOT HAS_ATTR_THREAD)
  CHECK_CXX_SOURCE_COMPILES("int main(void) { __declspec(thread) static int x; (void)x; return 0;}" HAS_DECLSPEC_THREAD)
endif()

CHECK_CXX_SOURCE_COMPILES("
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <libproc.h>
#include <unistd.h>

int main (int argc, char* argv[])
{
    pid_t pid = getpid(); 
    char path[PROC_PIDPATHINFO_MAXSIZE];
    (void) proc_pidpath (pid, path, sizeof(path));
    return 0;
}
" HAS_PIDPATH)

CHECK_CXX_SOURCE_COMPILES("
#include <windows.h>
int main (int argc, char* argv[]) {
  char path[MAX_PATH];
  (void) GetModuleFileName(NULL, path, MAX_PATH);
  return 0;
}" HAS_GETMODULEFILENAME)

CHECK_CXX_SOURCE_COMPILES("
#include <windows.h>
int main (int argc, char* argv[]) {
  (void) GetFileAttributes(NULL);
  return 0;
}" HAS_GETFILEATTRIBUTES)

CHECK_CXX_SOURCE_COMPILES("
#include <string.h>
int main (int argc, char* argv[]) {
  (void) memcpy_s(NULL,0,NULL,0);
  return 0;
}" HAS_MEMCPY_S)

SET (CMAKE_REQUIRED_DEFINITIONS "${SAFE_CMAKE_REQUIRED_DEFINITIONS}")

file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/minizinc)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc/html)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/include/minizinc/config.hh.in"
  "${PROJECT_BINARY_DIR}/minizinc/config.hh"
  )

include_directories("${PROJECT_BINARY_DIR}")

include_directories("${PROJECT_SOURCE_DIR}/include")

add_custom_target(MZNParser echo "Creating parser")

# When updating the cached files, update MD5 sums defined in this file
include(${PROJECT_SOURCE_DIR}/lib/cached/md5_cached.cmake)

macro(MD5 filename md5sum)
  file(READ "${filename}" RAW_MD5_FILE)
  string(REGEX REPLACE "\r" "" STRIPPED_MD5_FILE "${RAW_MD5_FILE}")
  string(MD5 ${md5sum} "${STRIPPED_MD5_FILE}")
endmacro(MD5)

find_program(FLEX_EXEC flex)
if(FLEX_EXEC)
  add_custom_command(
    OUTPUT "${PROJECT_BINARY_DIR}/lexer.yy.cpp"
    DEPENDS "${PROJECT_SOURCE_DIR}/lib/lexer.lxx"
    COMMAND "${FLEX_EXEC}" -L -o"${PROJECT_BINARY_DIR}/lexer.yy.cpp" "${PROJECT_SOURCE_DIR}/lib/lexer.lxx"
    )
  set_source_files_properties("${PROJECT_BINARY_DIR}/lexer.yy.cpp" GENERATED)
  set(lexer_cpp "${PROJECT_BINARY_DIR}/lexer.yy.cpp")
else(FLEX_EXEC)
  MD5("${PROJECT_SOURCE_DIR}/lib/lexer.lxx" lexer_lxx_md5)
  if(NOT "${lexer_lxx_md5}" STREQUAL "${lexer_lxx_md5_cached}")
    message(FATAL_ERROR "The file lexer.lxx has been modified but flex cannot be run.")
  endif()
  set(lexer_cpp "${PROJECT_SOURCE_DIR}/lib/cached/lexer.yy.cpp")
endif(FLEX_EXEC)

find_program(BISON_EXEC bison)
if(BISON_EXEC)
  add_custom_command(
    OUTPUT "${PROJECT_BINARY_DIR}/parser.tab.cpp"  "${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh"
    DEPENDS "${lexer_cpp}" "${PROJECT_SOURCE_DIR}/lib/parser.yxx"
    COMMAND "${BISON_EXEC}" -l -o "${PROJECT_BINARY_DIR}/parser.tab.cpp" --defines="${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh" "${PROJECT_SOURCE_DIR}/lib/parser.yxx"
    )
  set_source_files_properties("${PROJECT_BINARY_DIR}/parser.tab.cpp" GENERATED)
  set(parser_cpp "${PROJECT_BINARY_DIR}/parser.tab.cpp")
  set(parser_hh "${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh")
else(BISON_EXEC)
  MD5("${PROJECT_SOURCE_DIR}/lib/parser.yxx" parser_yxx_md5)
  if(NOT "${parser_yxx_md5}" STREQUAL "${parser_yxx_md5_cached}")
    message(FATAL_ERROR "The file parser.yxx has been modified but bison cannot be run.")
  endif()
  include_directories(${PROJECT_SOURCE_DIR}/lib/cached)
  set(parser_cpp "${PROJECT_SOURCE_DIR}/lib/cached/parser.tab.cpp")
  set(parser_hh "${PROJECT_SOURCE_DIR}/lib/cached/minizinc/parser.tab.hh")
endif(BISON_EXEC)


add_library(minizinc
lib/ast.cpp
lib/astexception.cpp
lib/aststring.cpp
lib/astvec.cpp
lib/builtins.cpp
lib/copy.cpp
lib/eval_par.cpp
lib/file_utils.cpp
lib/gc.cpp
lib/htmlprinter.cpp
"${lexer_cpp}"
lib/model.cpp
"${parser_cpp}"
lib/prettyprinter.cpp
lib/typecheck.cpp
lib/flatten.cpp
lib/optimize.cpp
lib/optimize_constraints.cpp
lib/parser.yxx
lib/lexer.lxx
lib/values.cpp
include/minizinc/ast.hh
include/minizinc/ast.hpp
include/minizinc/astexception.hh
include/minizinc/astiterator.hh
include/minizinc/aststring.hh
include/minizinc/astvec.hh
include/minizinc/builtins.hh
include/minizinc/config.hh.in
include/minizinc/copy.hh
include/minizinc/eval_par.hh
include/minizinc/exception.hh
include/minizinc/file_utils.hh
include/minizinc/flatten.hh
include/minizinc/flatten_internal.hh
include/minizinc/gc.hh
include/minizinc/hash.hh
include/minizinc/htmlprinter.hh
include/minizinc/iter.hh
include/minizinc/model.hh
include/minizinc/optimize.hh
include/minizinc/optimize_constraints.hh
include/minizinc/parser.hh
include/minizinc/prettyprinter.hh
include/minizinc/timer.hh
include/minizinc/type.hh
include/minizinc/typecheck.hh
include/minizinc/values.hh
include/minizinc/stl_map_set.hh
include/minizinc/thirdparty/SafeInt3.hpp
"${parser_hh}"
)

# add the executable
add_executable(mzn2fzn mzn2fzn.cpp)
target_link_libraries(mzn2fzn minizinc)

add_executable(solns2out solns2out.cpp)
target_link_libraries(solns2out minizinc)

add_executable(mzn2doc mzn2doc.cpp)
target_link_libraries(mzn2doc minizinc)

INSTALL(TARGETS mzn2fzn solns2out mzn2doc minizinc
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

option (BUILD_HTML_DOCUMENTATION "Build HTML documentation for the MiniZinc library" OFF)

if (BUILD_HTML_DOCUMENTATION)
  add_custom_target(doc ALL
    DEPENDS "mzn2doc"
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND mzn2doc --toplevel-groups 2
    --include-stdlib
    --html-header ${PROJECT_SOURCE_DIR}/doc/html/header.html
    --html-footer ${PROJECT_SOURCE_DIR}/doc/html/footer.html
      --output-base ${PROJECT_BINARY_DIR}/doc/html/doc share/minizinc/std/globals.mzn
  )
  FILE(COPY
       ${PROJECT_SOURCE_DIR}/doc/html/style.css
       ${PROJECT_SOURCE_DIR}/doc/html/header.html
       ${PROJECT_SOURCE_DIR}/doc/html/footer.html
       ${PROJECT_SOURCE_DIR}/doc/html/MiniZn_logo.jpg
       DESTINATION ${PROJECT_BINARY_DIR}/doc/html/)
  INSTALL(DIRECTORY ${PROJECT_BINARY_DIR}/doc/html DESTINATION doc)
endif()

option (BUILD_STATIC_EXECUTABLE "Build statically linked executables" OFF)

if (BUILD_STATIC_EXECUTABLE)
  set(CMAKE_EXE_LINKER_FLAGS -static)
endif()

INSTALL(DIRECTORY share/minizinc DESTINATION share)
INSTALL(DIRECTORY include/minizinc
        DESTINATION include
        PATTERN config.hh.in EXCLUDE
)
INSTALL(FILES ${PROJECT_BINARY_DIR}/minizinc/config.hh DESTINATION include/minizinc)
INSTALL(FILES README.txt INSTALL.txt LICENSE.txt DESTINATION doc/..)
INSTALL(DIRECTORY doc/pdf DESTINATION doc)
INSTALL(DIRECTORY share/examples DESTINATION share)
INSTALL(DIRECTORY lib/cached DESTINATION lib PATTERN md5_cached.cmake EXCLUDE)
INSTALL(FILES "${parser_hh}" DESTINATION include/minizinc)

SET(CPACK_PACKAGE_VERSION_MAJOR ${libminizinc_VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${libminizinc_VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${libminizinc_VERSION_PATCH})
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${CMake_VERSION_MAJOR}.${CMake_VERSION_MINOR}")
IF(WIN32 AND NOT UNIX)
  SET(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} My Famous Project")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.minizinc.org")
  SET(CPACK_NSIS_CONTACT "info@minizinc.org")
  SET(CPACK_NSIS_MODIFY_PATH ON)
  SET(CPACK_GENERATOR "ZIP")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_STRIP_FILES "bin/MyExecutable")
  SET(CPACK_SOURCE_STRIP_FILES "")
  SET(CPACK_GENERATOR "TGZ")
ENDIF(WIN32 AND NOT UNIX)

set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES
  "${CMAKE_CURRENT_BINARY_DIR}/;/tests/;/.git/;/.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

## minizinc 2.0.10+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # The version number.
 set (libminizinc_VERSION_MAJOR 2)
 set (libminizinc_VERSION_MINOR 0)
-set (libminizinc_VERSION_PATCH 8)
+set (libminizinc_VERSION_PATCH 10)
 
 if (ADDITIONAL_DATE_STRING)
   set (libminizinc_VERSION_PATCH "${libminizinc_VERSION_PATCH}.${ADDITIONAL_DATE_STRING}")
@@ -115,17 +115,23 @@
 
 file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/minizinc)
 file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc/html)
+file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc/pdf)
 
 # configure a header file to pass some of the CMake settings
 # to the source code
 configure_file (
-  "${PROJECT_SOURCE_DIR}/include/minizinc/config.hh.in"
-  "${PROJECT_BINARY_DIR}/minizinc/config.hh"
+  ${PROJECT_SOURCE_DIR}/include/minizinc/config.hh.in
+  ${PROJECT_BINARY_DIR}/minizinc/config.hh
   )
 
-include_directories("${PROJECT_BINARY_DIR}")
-
-include_directories("${PROJECT_SOURCE_DIR}/include")
+configure_file (
+  ${PROJECT_SOURCE_DIR}/doc/spec/version.tex.in
+  ${PROJECT_BINARY_DIR}/doc/pdf/version.tex
+  )
+
+include_directories(${PROJECT_BINARY_DIR})
+
+include_directories(${PROJECT_SOURCE_DIR}/include)
 
 add_custom_target(MZNParser echo "Creating parser")
 
@@ -141,38 +147,38 @@
 find_program(FLEX_EXEC flex)
 if(FLEX_EXEC)
   add_custom_command(
-    OUTPUT "${PROJECT_BINARY_DIR}/lexer.yy.cpp"
-    DEPENDS "${PROJECT_SOURCE_DIR}/lib/lexer.lxx"
-    COMMAND "${FLEX_EXEC}" -L -o"${PROJECT_BINARY_DIR}/lexer.yy.cpp" "${PROJECT_SOURCE_DIR}/lib/lexer.lxx"
+    OUTPUT ${PROJECT_BINARY_DIR}/lexer.yy.cpp
+    DEPENDS ${PROJECT_SOURCE_DIR}/lib/lexer.lxx
+    COMMAND ${FLEX_EXEC} -L -o${PROJECT_BINARY_DIR}/lexer.yy.cpp ${PROJECT_SOURCE_DIR}/lib/lexer.lxx
     )
-  set_source_files_properties("${PROJECT_BINARY_DIR}/lexer.yy.cpp" GENERATED)
-  set(lexer_cpp "${PROJECT_BINARY_DIR}/lexer.yy.cpp")
+  set_source_files_properties(${PROJECT_BINARY_DIR}/lexer.yy.cpp GENERATED)
+  set(lexer_cpp ${PROJECT_BINARY_DIR}/lexer.yy.cpp)
 else(FLEX_EXEC)
-  MD5("${PROJECT_SOURCE_DIR}/lib/lexer.lxx" lexer_lxx_md5)
+  MD5(${PROJECT_SOURCE_DIR}/lib/lexer.lxx lexer_lxx_md5)
   if(NOT "${lexer_lxx_md5}" STREQUAL "${lexer_lxx_md5_cached}")
     message(FATAL_ERROR "The file lexer.lxx has been modified but flex cannot be run.")
   endif()
-  set(lexer_cpp "${PROJECT_SOURCE_DIR}/lib/cached/lexer.yy.cpp")
+  set(lexer_cpp ${PROJECT_SOURCE_DIR}/lib/cached/lexer.yy.cpp)
 endif(FLEX_EXEC)
 
 find_program(BISON_EXEC bison)
 if(BISON_EXEC)
   add_custom_command(
-    OUTPUT "${PROJECT_BINARY_DIR}/parser.tab.cpp"  "${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh"
-    DEPENDS "${lexer_cpp}" "${PROJECT_SOURCE_DIR}/lib/parser.yxx"
-    COMMAND "${BISON_EXEC}" -l -o "${PROJECT_BINARY_DIR}/parser.tab.cpp" --defines="${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh" "${PROJECT_SOURCE_DIR}/lib/parser.yxx"
+    OUTPUT ${PROJECT_BINARY_DIR}/parser.tab.cpp ${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh
+    DEPENDS ${lexer_cpp} ${PROJECT_SOURCE_DIR}/lib/parser.yxx
+    COMMAND "${BISON_EXEC}" -l -o ${PROJECT_BINARY_DIR}/parser.tab.cpp --defines=${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh ${PROJECT_SOURCE_DIR}/lib/parser.yxx
     )
-  set_source_files_properties("${PROJECT_BINARY_DIR}/parser.tab.cpp" GENERATED)
-  set(parser_cpp "${PROJECT_BINARY_DIR}/parser.tab.cpp")
-  set(parser_hh "${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh")
+  set_source_files_properties(${PROJECT_BINARY_DIR}/parser.tab.cpp GENERATED)
+  set(parser_cpp ${PROJECT_BINARY_DIR}/parser.tab.cpp)
+  set(parser_hh ${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh)
 else(BISON_EXEC)
-  MD5("${PROJECT_SOURCE_DIR}/lib/parser.yxx" parser_yxx_md5)
+  MD5(${PROJECT_SOURCE_DIR}/lib/parser.yxx parser_yxx_md5)
   if(NOT "${parser_yxx_md5}" STREQUAL "${parser_yxx_md5_cached}")
     message(FATAL_ERROR "The file parser.yxx has been modified but bison cannot be run.")
   endif()
   include_directories(${PROJECT_SOURCE_DIR}/lib/cached)
-  set(parser_cpp "${PROJECT_SOURCE_DIR}/lib/cached/parser.tab.cpp")
-  set(parser_hh "${PROJECT_SOURCE_DIR}/lib/cached/minizinc/parser.tab.hh")
+  set(parser_cpp ${PROJECT_SOURCE_DIR}/lib/cached/parser.tab.cpp)
+  set(parser_hh ${PROJECT_SOURCE_DIR}/lib/cached/minizinc/parser.tab.hh)
 endif(BISON_EXEC)
 
 
@@ -187,9 +193,9 @@
 lib/file_utils.cpp
 lib/gc.cpp
 lib/htmlprinter.cpp
-"${lexer_cpp}"
+${lexer_cpp}
 lib/model.cpp
-"${parser_cpp}"
+${parser_cpp}
 lib/prettyprinter.cpp
 lib/typecheck.cpp
 lib/flatten.cpp
@@ -227,7 +233,7 @@
 include/minizinc/values.hh
 include/minizinc/stl_map_set.hh
 include/minizinc/thirdparty/SafeInt3.hpp
-"${parser_hh}"
+${parser_hh}
 )
 
 # add the executable
@@ -251,7 +257,7 @@
 if (BUILD_HTML_DOCUMENTATION)
   add_custom_target(doc ALL
     DEPENDS "mzn2doc"
-    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
+    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
     COMMAND mzn2doc --toplevel-groups 2
     --include-stdlib
     --html-header ${PROJECT_SOURCE_DIR}/doc/html/header.html
@@ -267,6 +273,16 @@
   INSTALL(DIRECTORY ${PROJECT_BINARY_DIR}/doc/html DESTINATION doc)
 endif()
 
+option (BUILD_PDF_DOCUMENTATION "Build PDF documentation for the MiniZinc language" OFF)
+
+if (BUILD_PDF_DOCUMENTATION)
+  add_custom_target(doc_spec ALL
+    DEPENDS doc/spec/common-spec.tex doc/spec/minizinc-spec.tex
+    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/doc/spec
+    COMMAND latexmk -pdf -output-directory=${PROJECT_BINARY_DIR}/doc/pdf minizinc-spec
+  )
+endif()
+
 option (BUILD_STATIC_EXECUTABLE "Build statically linked executables" OFF)
 
 if (BUILD_STATIC_EXECUTABLE)
@@ -283,7 +299,7 @@
 INSTALL(DIRECTORY doc/pdf DESTINATION doc)
 INSTALL(DIRECTORY share/examples DESTINATION share)
 INSTALL(DIRECTORY lib/cached DESTINATION lib PATTERN md5_cached.cmake EXCLUDE)
-INSTALL(FILES "${parser_hh}" DESTINATION include/minizinc)
+INSTALL(FILES ${parser_hh} DESTINATION include/minizinc)
 
 SET(CPACK_PACKAGE_VERSION_MAJOR ${libminizinc_VERSION_MAJOR})
 SET(CPACK_PACKAGE_VERSION_MINOR ${libminizinc_VERSION_MINOR})

## minizinc 2.0.11%2Bdfsg1

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_PARALLEL := 1

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

MINIZINC_DOC := $(CURDIR)/debian/minizinc/usr/share/doc/minizinc/
DEB_CMAKE_EXTRA_FLAGS := -DBUILD_HTML_DOCUMENTATION=ON -DBUILD_PDF_DOCUMENTATION=ON
DEB_COMPRESS_EXCLUDE := minizinc-spec.pdf

binary-post-install/minizinc::
	rm -rf $(CURDIR)/debian/minizinc/usr/lib $(CURDIR)/debian/minizinc/usr/include
	rm -f $(MINIZINC_DOC)/LICENSE.txt $(MINIZINC_DOC)/INSTALL.txt $(MINIZINC_DOC)/README.txt $(MINIZINC_DOC)/CHANGES.txt
	cp $(CURDIR)/README.txt $(CURDIR)/debian/minizinc/usr/share/doc/minizinc/README
	cp $(CURDIR)/CHANGES.txt $(CURDIR)/debian/minizinc/usr/share/doc/minizinc/changelog

# Add here any variable or target overrides you need.

## minizinc 2.0.11+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # The version number.
 set (libminizinc_VERSION_MAJOR 2)
 set (libminizinc_VERSION_MINOR 0)
-set (libminizinc_VERSION_PATCH 10)
+set (libminizinc_VERSION_PATCH 11)
 
 if (ADDITIONAL_DATE_STRING)
   set (libminizinc_VERSION_PATCH "${libminizinc_VERSION_PATCH}.${ADDITIONAL_DATE_STRING}")

=== debian/changelog ===
minizinc (2.0.11+dfsg1-1) unstable; urgency=medium

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Sun, 17 Jan 2016 17:54:50 +0200

minizinc (2.0.10+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Build html documentation.
  * Build pdf spec documentation and add mklatex and
    texlive-latex-recommended as build deps.
  * Add minizinc.doc-base.
  * Changes to patch install-cleanups to adjust install directories.

 -- Kari Pahula <kaol@debian.org>  Sat, 02 Jan 2016 20:44:57 +0200

minizinc (2.0.8+dfsg1-1) unstable; urgency=medium

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Sun, 25 Oct 2015 11:10:18 +0200

minizinc (2.0.5+dfsg1-1) experimental; urgency=low

  * Initial release (Closes: #791608)

 -- Kari Pahula <kaol@debian.org>  Mon, 03 Aug 2015 10:08:56 +0300

=== debian/control ===
Source: minizinc
Section: devel
Priority: extra
Maintainer: Kari Pahula <kaol@debian.org>
Build-Depends: cdbs, debhelper (>= 9), cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended
Standards-Version: 3.9.6
Homepage: http://www.minizinc.org/

Package: minizinc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, flatzinc
Enhances: flatzinc
Description: constraint modelling language and tool chain
 MiniZinc is a medium-level constraint modelling language. It is
 high-level enough to express most constraint problems easily, but
 low-level enough that it can be mapped onto existing solvers easily
 and consistently. It is a subset of the higher-level language Zinc.
 .
 MiniZinc is designed to interface easily to different backend
 solvers.  It does this by transforming an input MiniZinc model and
 data file into a FlatZinc model. FlatZinc models consist of variable
 declaration and constraint definitions as well as a definition of the
 objective function if the problem is an optimization problem. The
 translation from MiniZinc to FlatZinc is specializable to individual
 backend solvers, so they can control what form constraints end up
 in. In particular, MiniZinc allows the specification of global
 constraints by decomposition.

## minizinc 2.0.13+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # The version number.
 set (libminizinc_VERSION_MAJOR 2)
 set (libminizinc_VERSION_MINOR 0)
-set (libminizinc_VERSION_PATCH 11)
+set (libminizinc_VERSION_PATCH 13)
 
 if (ADDITIONAL_DATE_STRING)
   set (libminizinc_VERSION_PATCH "${libminizinc_VERSION_PATCH}.${ADDITIONAL_DATE_STRING}")

=== debian/changelog ===
minizinc (2.0.13+dfsg1-1ubuntu1) yakkety; urgency=medium

  * debian/patches/glibc-2.23: Include cmath to fix undefined floor and ceil.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 05 May 2016 22:58:16 -0400

minizinc (2.0.13+dfsg1-1) unstable; urgency=medium

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Thu, 07 Apr 2016 21:12:57 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: minizinc
 Section: devel
 Priority: extra
-Maintainer: Kari Pahula <kaol@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kari Pahula <kaol@debian.org>
 Build-Depends: cdbs, debhelper (>= 9), cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended
 Standards-Version: 3.9.6
 Homepage: http://www.minizinc.org/

## minizinc 2.0.14+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # The version number.
 set (libminizinc_VERSION_MAJOR 2)
 set (libminizinc_VERSION_MINOR 0)
-set (libminizinc_VERSION_PATCH 13)
+set (libminizinc_VERSION_PATCH 14)
 
 if (ADDITIONAL_DATE_STRING)
   set (libminizinc_VERSION_PATCH "${libminizinc_VERSION_PATCH}.${ADDITIONAL_DATE_STRING}")

=== debian/changelog ===
minizinc (2.0.14+dfsg1-1) unstable; urgency=medium

  * New upstream release
    - Include cmath where needed. (Closes: #830457)
  * Bump standards-version to 3.9.8 (no changes necessary).

 -- Kari Pahula <kaol@debian.org>  Sun, 28 Aug 2016 18:44:29 +0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: minizinc
 Section: devel
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kari Pahula <kaol@debian.org>
+Maintainer: Kari Pahula <kaol@debian.org>
 Build-Depends: cdbs, debhelper (>= 9), cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.minizinc.org/
 
 Package: minizinc

## minizinc 2.1.5+dfsg1

=== debian/changelog ===
minizinc (2.1.5+dfsg1-1) unstable; urgency=medium

  * New upstream release
    - Upstream provides now mzn-fzn binary which takes the role of
      minizinc binary in 1.6 release.  (Closes: #830973)
  * Standards-Version 4.0.0 (no changes necessary).
  * Add generated files lib/cached/{parser.tab.cpp,lexer.yy.cpp} to
    debian/clean.
  * Add debian/watch file. (Closes: #866212)
  * Rework the patch on CMakeLists.txt to make fewer changes to it and fix
    more errant files in debian/rules instead.
  * Stop linking /usr/share/minizinc/gecode to gecode's mznlib directory
    as the definitons there turn out to not be compatible.
  * Drop Enhances: flatzinc from minizinc.

 -- Kari Pahula <kaol@debian.org>  Tue, 18 Jul 2017 22:46:10 +0300

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,12 @@
 Priority: extra
 Maintainer: Kari Pahula <kaol@debian.org>
 Build-Depends: cdbs, debhelper (>= 9), cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.minizinc.org/
 
 Package: minizinc
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, flatzinc
-Enhances: flatzinc
+Depends: ${shlibs:Depends}, ${misc:Depends}, flatzinc (>= 5.1.0-1)
 Description: constraint modelling language and tool chain
  MiniZinc is a medium-level constraint modelling language. It is
  high-level enough to express most constraint problems easily, but

## minizinc 2.1.7+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.0)

project (libminizinc CXX C)

# -------------------------------------------------------------------------------------------------------------------
# -- The below checks if certain solver paths are set in the config call for the corresp. interface to be compiled --
# ---- For example, to produce mzn-gecode run "cd build; cmake -D GECODE_HOME=$GECODE_HOME ..; cmake --build ."  ----
# -------------------------------------------------------------------------------------------------------------------
set(HAS_FZN    TRUE)                 ### Always compile the mzn-fzn driver
if (DEFINED GECODE_HOME AND NOT "${GECODE_HOME} " STREQUAL " ")
  set(HAS_GECODE TRUE)
endif()
if (DEFINED CPLEX_STUDIO_DIR AND NOT "${CPLEX_STUDIO_DIR} " STREQUAL " ")
  set(HAS_CPLEX TRUE)
endif()
if(DEFINED GUROBI_HOME AND NOT "${GUROBI_HOME} " STREQUAL " ")
  set(HAS_GUROBI TRUE)
endif()
if (DEFINED SCIP_DIR AND DEFINED SOPLEX_DIR AND DEFINED ZIMPL_DIR AND NOT "${SCIP_DIR} " STREQUAL " ")
  set(HAS_SCIP TRUE)                     # Can use SCIP w/o ZIMPL too
endif()
if (DEFINED OSICBC_HOME AND NOT "${OSICBC_HOME} " STREQUAL " ")
  set(HAS_OSICBC TRUE)
endif()

# -------------------------------------------------------------------------------------------------------------------
# The version number.
set (libminizinc_VERSION_MAJOR 2)
set (libminizinc_VERSION_MINOR 1)
set (libminizinc_VERSION_PATCH 7)

if (ADDITIONAL_DATE_STRING)
  set (libminizinc_VERSION_PATCH "${libminizinc_VERSION_PATCH}.${ADDITIONAL_DATE_STRING}")
endif()

# -------------------------------------------------------------------------------------------------------------------
option (USE_ADDRESS_SANITIZER "Use GCC Address Sanitizer" OFF)
if (USE_ADDRESS_SANITIZER)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif()

# -------------------------------------------------------------------------------------------------------------------
option (BUILD_STATIC_EXECUTABLE "Build statically linked executables" OFF)  ## does not work TODO
if (BUILD_STATIC_EXECUTABLE)
#  SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
#  SET(BUILD_SHARED_LIBRARIES OFF)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
endif()

include (CheckIncludeFiles)

# -------------------------------------------------------------------------------------------------------------------
option (BUILD_GUROBI_PLUGIN "Build Gurobi binding as a plugin" OFF)
if (BUILD_GUROBI_PLUGIN)
  if(HAS_GUROBI)
    CHECK_INCLUDE_FILES (dlfcn.h HAS_DLFCN_H)
    if(HAS_DLFCN_H)
      find_library (NEEDS_LIBDL NAMES dl)
    endif()
    CHECK_INCLUDE_FILES (Windows.h HAS_WINDOWS_H)
    if(HAS_DLFCN_H OR HAS_WINDOWS_H)
      set(HAS_GUROBI_PLUGIN TRUE)
    endif()
  endif()
endif()


# -------------------------------------------------------------------------------------------------------------------

if(APPLE)
  execute_process(COMMAND xcrun --show-sdk-path OUTPUT_VARIABLE OSX_SYSROOT OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(CMAKE_OSX_SYSROOT ${OSX_SYSROOT})
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")
endif(APPLE)

include(CheckCXXCompilerFlag)

SET(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
check_cxx_compiler_flag(-Werror HAS_WERROR)

if (HAS_WERROR)
  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
endif()

if ( (CMAKE_VERSION VERSION_GREATER 3.1.0) OR (CMAKE_VERSION VERSION_EQUAL 3.1.0) )
  set (CMAKE_CXX_STANDARD 11)
else()
  check_cxx_compiler_flag(-std=c++11 HAS_STDCPP11)
  if (HAS_STDCPP11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  else()
    check_cxx_compiler_flag(-std=c++0x HAS_STDCPP0X)
    if (HAS_STDCPP0X)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    else()
      message(SEND_ERROR "CMake >= 3.1.0 required to detect whether compiler supports C++11")
    endif()
  endif()
endif()

# -------------------------------------------------------------------------------------------------------------------
if (USE_STDLIBCPP)
  set(MZN_LIBCPP libstdc++)
  set(SAFE_CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=${MZN_LIBCPP}")
  check_cxx_source_compiles("int main(void) {return 0;}" LINKS_STDLIBLIBCPP)
  if (NOT LINKS_STDLIBLIBCPP)
    set(CMAKE_CXX_FLAGS "${SAFE_CMAKE_CXX_FLAGS}")
  endif()
endif()

check_cxx_source_compiles("#include <unordered_set>
int main(void) { std::unordered_set<int> x; return 0; }" HAS_CPP11)

if (NOT HAS_CPP11)
  check_cxx_source_compiles("#include <tr1/unordered_set>
                             int main(void) { std::tr1::unordered_set<int> x; return 0; }" HAS_CPP11_TR1)
  if (HAS_CPP11_TR1)
    set(MZN_NEED_TR1 1)
  else()
    message(FATAL_ERROR "A c++11 compatible C++ standard library is required to build libminizinc.")
  endif()
endif()
   
CHECK_CXX_SOURCE_COMPILES("int main(void) { static __thread int x; (void)x; return 0;}" HAS_ATTR_THREAD)

if (NOT HAS_ATTR_THREAD)
  CHECK_CXX_SOURCE_COMPILES("int main(void) { __declspec(thread) static int x; (void)x; return 0;}" HAS_DECLSPEC_THREAD)
endif()

CHECK_CXX_SOURCE_COMPILES("#include <cstdlib>
int main(void) { long long int x = atoll(\"123\"); (void)x; }" HAS_ATOLL)
CHECK_CXX_SOURCE_COMPILES("
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <libproc.h>
#include <unistd.h>

int main (int argc, char* argv[])
{
    pid_t pid = getpid(); 
    char path[PROC_PIDPATHINFO_MAXSIZE];
    (void) proc_pidpath (pid, path, sizeof(path));
    return 0;
}
" HAS_PIDPATH)

CHECK_CXX_SOURCE_COMPILES("
#include <windows.h>
int main (int argc, char* argv[]) {
  char path[MAX_PATH];
  (void) GetModuleFileName(NULL, path, MAX_PATH);
  return 0;
}" HAS_GETMODULEFILENAME)

CHECK_CXX_SOURCE_COMPILES("
#include <windows.h>
int main (int argc, char* argv[]) {
  (void) GetFileAttributes(NULL);
  return 0;
}" HAS_GETFILEATTRIBUTES)

CHECK_CXX_SOURCE_COMPILES("
#include <string.h>
int main (int argc, char* argv[]) {
  (void) memcpy_s(NULL,0,NULL,0);
  return 0;
}" HAS_MEMCPY_S)

#check_cxx_source_compiles("#include <sstream>
##include <iomanip>
#int main(void) { std::ostringstream oss; std::hexfloat(oss); return 0; }" HAS_HEXFLOAT)

# -------------------------------------------------------------------------------------------------------------------
SET (CMAKE_REQUIRED_DEFINITIONS "${SAFE_CMAKE_REQUIRED_DEFINITIONS}")

file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/minizinc)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc/html)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc/pdf)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  ${PROJECT_SOURCE_DIR}/include/minizinc/config.hh.in
  ${PROJECT_BINARY_DIR}/minizinc/config.hh
  )

configure_file (
  ${PROJECT_SOURCE_DIR}/doc/spec/version.tex.in
  ${PROJECT_BINARY_DIR}/doc/pdf/version.tex
  )

include_directories(${PROJECT_BINARY_DIR})

include_directories(${PROJECT_SOURCE_DIR}/include)

add_custom_target(MZNParser echo "Creating parser")

# When updating the cached files, update MD5 sums defined in this file
include(${PROJECT_SOURCE_DIR}/lib/cached/md5_cached.cmake)

macro(MD5 filename md5sum)
  file(READ "${filename}" RAW_MD5_FILE)
  string(REGEX REPLACE "\r" "" STRIPPED_MD5_FILE "${RAW_MD5_FILE}")
  string(MD5 ${md5sum} "${STRIPPED_MD5_FILE}")
endmacro(MD5)

find_program(FLEX_EXEC flex)
if(FLEX_EXEC)
  add_custom_command(
    OUTPUT ${PROJECT_BINARY_DIR}/lexer.yy.cpp
    DEPENDS ${PROJECT_SOURCE_DIR}/lib/lexer.lxx
    COMMAND ${FLEX_EXEC} -L -o${PROJECT_BINARY_DIR}/lexer.yy.cpp ${PROJECT_SOURCE_DIR}/lib/lexer.lxx
    )
  set_source_files_properties(${PROJECT_BINARY_DIR}/lexer.yy.cpp GENERATED)
  set(lexer_cpp ${PROJECT_BINARY_DIR}/lexer.yy.cpp)
else(FLEX_EXEC)
  MD5(${PROJECT_SOURCE_DIR}/lib/lexer.lxx lexer_lxx_md5)
  if(NOT "${lexer_lxx_md5}" STREQUAL "${lexer_lxx_md5_cached}")
    message(FATAL_ERROR "The file lexer.lxx has been modified but flex cannot be run."
	  "\nIf you are sure ${PROJECT_SOURCE_DIR}/lib/cached/lexer.yy.cpp is correct then"
	  "copy lexer.lxx's md5 md5 ${lexer_lxx_md5} into ${PROJECT_SOURCE_DIR}/lib/cached/md5_cached.cmake")
  endif()
  set(lexer_cpp ${PROJECT_SOURCE_DIR}/lib/cached/lexer.yy.cpp)
endif(FLEX_EXEC)

find_program(BISON_EXEC bison)
if(BISON_EXEC)
  add_custom_command(
    OUTPUT ${PROJECT_BINARY_DIR}/parser.tab.cpp ${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh
    DEPENDS ${lexer_cpp} ${PROJECT_SOURCE_DIR}/lib/parser.yxx
    COMMAND "${BISON_EXEC}" -l -o ${PROJECT_BINARY_DIR}/parser.tab.cpp --defines=${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh ${PROJECT_SOURCE_DIR}/lib/parser.yxx
    )
  set_source_files_properties(${PROJECT_BINARY_DIR}/parser.tab.cpp GENERATED)
  set(parser_cpp ${PROJECT_BINARY_DIR}/parser.tab.cpp)
  set(parser_hh ${PROJECT_BINARY_DIR}/minizinc/parser.tab.hh)
else(BISON_EXEC)
  MD5(${PROJECT_SOURCE_DIR}/lib/parser.yxx parser_yxx_md5)
  if(NOT "${parser_yxx_md5}" STREQUAL "${parser_yxx_md5_cached}")
    message(FATAL_ERROR "The file parser.yxx has been modified but bison cannot be run."
	  "\nIf you are sure parser.tab.cpp and minizinc/parser.tab.hh in ${PROJECT_SOURCE_DIR}/lib/cached/ are correct then"
	  "copy parser.yxx's md5 ${parser_yxx_md5} into ${PROJECT_SOURCE_DIR}/lib/cached/md5_cached.cmake")
  endif()
  include_directories(${PROJECT_SOURCE_DIR}/lib/cached)
  set(parser_cpp ${PROJECT_SOURCE_DIR}/lib/cached/parser.tab.cpp)
  set(parser_hh ${PROJECT_SOURCE_DIR}/lib/cached/minizinc/parser.tab.hh)
endif(BISON_EXEC)

# -------------------------------------------------------------------------------------------------------------------
add_library(minizinc
lib/ast.cpp
lib/astexception.cpp
lib/aststring.cpp
lib/astvec.cpp
lib/builtins.cpp
lib/cli.cpp
lib/copy.cpp
lib/eval_par.cpp
lib/file_utils.cpp
lib/gc.cpp
lib/htmlprinter.cpp
lib/json_parser.cpp
${lexer_cpp}
lib/model.cpp
${parser_cpp}
lib/prettyprinter.cpp
lib/solver.cpp
lib/solver_instance.cpp
lib/solver_instance_base.cpp
lib/type.cpp
lib/typecheck.cpp
lib/flatten.cpp
lib/flattener.cpp
lib/MIPdomains.cpp
lib/optimize.cpp
lib/options.cpp
lib/optimize_constraints.cpp
lib/output.cpp
lib/parser.yxx
lib/solns2out_class.cpp
lib/statistics.cpp
lib/lexer.lxx
lib/values.cpp
include/minizinc/ast.hh
include/minizinc/ast.hpp
include/minizinc/astexception.hh
include/minizinc/astiterator.hh
include/minizinc/aststring.hh
include/minizinc/astvec.hh
include/minizinc/builtins.hh
include/minizinc/cli.hh
include/minizinc/config.hh.in
include/minizinc/copy.hh
include/minizinc/eval_par.hh
include/minizinc/exception.hh
include/minizinc/file_utils.hh
include/minizinc/flatten.hh
include/minizinc/flatten_internal.hh
include/minizinc/flattener.hh
include/minizinc/gc.hh
include/minizinc/hash.hh
include/minizinc/htmlprinter.hh
include/minizinc/iter.hh
include/minizinc/json_parser.hh
include/minizinc/model.hh
include/minizinc/optimize.hh
include/minizinc/optimize_constraints.hh
include/minizinc/options.hh
include/minizinc/output.hh
include/minizinc/parser.hh
include/minizinc/prettyprinter.hh
include/minizinc/solver.hh
include/minizinc/solver_instance.hh
include/minizinc/solver_instance_base.hh
include/minizinc/statistics.hh
include/minizinc/stl_map_set.hh
include/minizinc/timer.hh
include/minizinc/type.hh
include/minizinc/typecheck.hh
include/minizinc/values.hh
include/minizinc/stl_map_set.hh
include/minizinc/thirdparty/SafeInt3.hpp
${parser_hh}
)

# add the executable
add_executable(mzn2fzn minizinc.cpp)    #mzn2fzn.cpp)
target_link_libraries(mzn2fzn minizinc)
target_compile_definitions(mzn2fzn PRIVATE -DFLATTEN_ONLY)

add_executable(mzn2fzn_test mzn2fzn_test.cpp)
target_link_libraries(mzn2fzn_test minizinc)

add_executable(solns2out solns2out.cpp)
target_link_libraries(solns2out minizinc)

find_package ( Threads REQUIRED )

# -------------------------------------------------------------------------------------------------------------------

=== debian/changelog ===
minizinc (2.1.7+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version 4.1.3
    - Set Priority: optional.

 -- Kari Pahula <kaol@debian.org>  Tue, 23 Jan 2018 18:20:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: minizinc
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
 Build-Depends: cdbs, debhelper (>= 9), cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Homepage: http://www.minizinc.org/
 
 Package: minizinc

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,10 @@
 DEB_COMPRESS_EXCLUDE := minizinc-spec.pdf
 
 binary-post-install/minizinc::
+	mv $(CURDIR)/debian/minizinc/usr/doc/pdf/minizinc-spec.pdf $(MINIZINC_DOC)
+	rm -rf $(CURDIR)/debian/minizinc/usr/doc $(CURDIR)/debian/minizinc/usr/share/examples
 	rm -rf $(CURDIR)/debian/minizinc/usr/lib $(CURDIR)/debian/minizinc/usr/include
+	rm -f $(CURDIR)/debian/minizinc/usr/*.txt
 	rm -f $(MINIZINC_DOC)/LICENSE.txt $(MINIZINC_DOC)/INSTALL.txt $(MINIZINC_DOC)/README.txt $(MINIZINC_DOC)/CHANGES.txt
 	cp $(CURDIR)/README.txt $(CURDIR)/debian/minizinc/usr/share/doc/minizinc/README
 	cp $(CURDIR)/CHANGES.txt $(CURDIR)/debian/minizinc/usr/share/doc/minizinc/changelog
-
-# Add here any variable or target overrides you need.

## minizinc 2.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.0)

# -------------------------------------------------------------------------------------------------------------------
#  -- Project information and versioning.

project(libminizinc
        VERSION 2.4.2
        LANGUAGES CXX C)

if(NOT BUILD_REF)
  set(BUILD_REF "")
endif()

# -------------------------------------------------------------------------------------------------------------------
#  -- Project build options

# Driver compilation selection
option(USE_CPLEX "Enable the CPLEX solving target" TRUE)
option(USE_GEAS "Enable the Geas solving target" TRUE)
option(USE_GECODE "Enable the Gecode solving target" TRUE)
option(USE_GUROBI "Enable the Gurobi solving target" TRUE)
option(USE_OSICBC "Enable the Osi CBC solving target" TRUE)
option(USE_SCIP "Enable the SCIP solving target" TRUE)
option(USE_XPRESS "Enable the Xpress solving target" TRUE)

# Static vs. Dynamic linking
option(CPLEX_PLUGIN "Build CPLEX binding as a plugin" ON)
option(GUROBI_PLUGIN "Build Gurobi binding as a plugin" ON)

# Enforce non proprietary build
option(USE_PROPRIETARY "Enable static linking of proprietary solvers" OFF)
if(NOT USE_PROPRIETARY)
  set(CPLEX_PLUGIN ON)
  set(GUROBI_PLUGIN ON)
  set(USE_SCIP OFF)
endif()

# Export compile commands (useful when working with visual studio code)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# -------------------------------------------------------------------------------------------------------------------
#  -- CMake initialisation

# Fix library suffixes for Web Assembly platform
include(cmake/support/emscripten_setup.cmake)

# Try to find possible dependencies
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif(POLICY CMP0074)
find_package(CPlex)
find_package(Geas)
find_package(Gecode 6.0 COMPONENTS Driver Float Int Kernel Minimodel Search Set Support)
find_package(Gurobi)
find_package(OsiCBC)
find_package(SCIP CONFIG)
find_package(Xpress)

# Set build type when none is selected
set(DEFAULT_BUILD_TYPE "Release")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
               "Debug"
               "Release"
               "MinSizeRel"
               "RelWithDebInfo")
endif()

# -------------------------------------------------------------------------------------------------------------------
#  -- Compiler configuration

include(cmake/support/ccache_setup.cmake)
include(cmake/support/compiler_setup.cmake)

configure_file(
  ${PROJECT_SOURCE_DIR}/include/minizinc/config.hh.in
  ${PROJECT_BINARY_DIR}/include/minizinc/config.hh
)

install(
  FILES ${PROJECT_BINARY_DIR}/include/minizinc/config.hh
  DESTINATION include/minizinc
)

# -------------------------------------------------------------------------------------------------------------------
#  -- MiniZinc compilation targets.

find_package(Threads REQUIRED)
include_directories(${PROJECT_SOURCE_DIR}/include)
include_directories(${PROJECT_BINARY_DIR}/include)

# Libraries
include(cmake/targets/libmzn.cmake)

# Executables
include(cmake/targets/minizinc.cmake)
include(cmake/targets/mzn2doc.cmake)

# -------------------------------------------------------------------------------------------------------------------
#  -- Platform Specific configuration
include(cmake/support/config_emscripten.cmake)

# -------------------------------------------------------------------------------------------------------------------
#  -- CMake configuration generation

include(cmake/support/config_export.cmake)
include(cmake/support/config_output.cmake)

=== tests/requirements.txt ===
PyYAML==5.1.2
pytest==5.3.1
py==1.8.0
pytest-html==2.0.1
pytest-xdist==1.30.0
pytest-instafail==0.4.1.post0
git+https://gitlab.com/minizinc/minizinc-python.git@develop

=== debian/changelog ===
minizinc (2.4.2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:15:12 +0100

minizinc (2.4.2-1) unstable; urgency=medium

  * New upstream release (Closes: #923525)

 -- Kari Pahula <kaol@debian.org>  Fri, 10 Jan 2020 13:53:50 +0200

minizinc (2.4.1-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version 4.4.1
    - Switch build system to dh
  * Use USE_GECODE build flag and add libgecode-dev as a build dep
  * Remove no longer used debian/patches

 -- Kari Pahula <kaol@debian.org>  Wed, 01 Jan 2020 12:43:20 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: devel
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: cdbs, debhelper (>= 9), cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended
-Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 11), dh-exec, cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended, libgecode-dev (>= 6.2.0)
+Standards-Version: 4.4.1
 Homepage: http://www.minizinc.org/
 
 Package: minizinc
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, flatzinc (>= 5.1.0-1)
+Depends: ${shlibs:Depends}, ${misc:Depends}, flatzinc (>= 6.2.0-1)
+Breaks: minizinc-ide (<< 2.4.0~)
 Description: constraint modelling language and tool chain
  MiniZinc is a medium-level constraint modelling language. It is
  high-level enough to express most constraint problems easily, but

## minizinc 2.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,11 @@
 cmake_minimum_required(VERSION 3.4.0)
+set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version") # Must be before project()
 
 # -------------------------------------------------------------------------------------------------------------------
 #  -- Project information and versioning.
 
 project(libminizinc
-        VERSION 2.4.2
+        VERSION 2.4.3
         LANGUAGES CXX C)
 
 if(NOT BUILD_REF)
@@ -32,7 +33,6 @@
 if(NOT USE_PROPRIETARY)
   set(CPLEX_PLUGIN ON)
   set(GUROBI_PLUGIN ON)
-  set(USE_SCIP OFF)
 endif()
 
 # Export compile commands (useful when working with visual studio code)
@@ -54,7 +54,7 @@
 find_package(Gecode 6.0 COMPONENTS Driver Float Int Kernel Minimodel Search Set Support)
 find_package(Gurobi)
 find_package(OsiCBC)
-find_package(SCIP CONFIG)
+find_package(SCIP)
 find_package(Xpress)
 
 # Set build type when none is selected

=== tests/requirements.txt ===
PyYAML==5.3
pytest==5.3.5
py==1.8.1
pytest-html==2.0.1
pytest-xdist==1.31.0
pytest-instafail==0.4.1.post0
minizinc==0.2.2

=== debian/changelog ===
minizinc (2.4.3-3) unstable; urgency=medium

  * Symlink parser.tab.hh and regex_parser.tab.hh in build dir root to
    make Bison 3.7 generated parser.tab.cpp and regex_parser.tab.cpp
    happy.  (Closes: #966905)
  * Disambiguate file glob in debian/copyright.

 -- Kari Pahula <kaol@debian.org>  Sat, 08 Aug 2020 23:13:21 +0300

minizinc (2.4.3-2) unstable; urgency=medium

  * Protect "Current" in YYLLOC_DEFAULT macro with parentheses in
    lib/parser.y to build with new Bison (Closes: #960404)
  * Standards-Version 4.5.0 and dh compat 13 (no changes necessary)

 -- Kari Pahula <kaol@debian.org>  Wed, 13 May 2020 12:59:18 +0300

minizinc (2.4.3-1) unstable; urgency=medium

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Thu, 02 Apr 2020 20:17:27 +0300

## minizinc 2.5.1

=== debian/changelog ===
minizinc (2.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove Bison patches.

 -- Kari Pahula <kaol@debian.org>  Thu, 22 Oct 2020 19:25:30 +0300

## minizinc 2.5.3+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #  -- Project information and versioning.
 
 project(libminizinc
-        VERSION 2.4.3
+        VERSION 2.5.3
         LANGUAGES CXX C)
 
 if(NOT BUILD_REF)
@@ -15,18 +15,9 @@
 # -------------------------------------------------------------------------------------------------------------------
 #  -- Project build options
 
-# Driver compilation selection
-option(USE_CPLEX "Enable the CPLEX solving target" TRUE)
-option(USE_GEAS "Enable the Geas solving target" TRUE)
-option(USE_GECODE "Enable the Gecode solving target" TRUE)
-option(USE_GUROBI "Enable the Gurobi solving target" TRUE)
-option(USE_OSICBC "Enable the Osi CBC solving target" TRUE)
-option(USE_SCIP "Enable the SCIP solving target" TRUE)
-option(USE_XPRESS "Enable the Xpress solving target" TRUE)
-
 # Static vs. Dynamic linking
-option(CPLEX_PLUGIN "Build CPLEX binding as a plugin" ON)
-option(GUROBI_PLUGIN "Build Gurobi binding as a plugin" ON)
+option(CPlex_PLUGIN "Build CPLEX binding as a plugin" ON)
+option(Gurobi_PLUGIN "Build Gurobi binding as a plugin" ON)
 
 # Enforce non proprietary build
 option(USE_PROPRIETARY "Enable static linking of proprietary solvers" OFF)
@@ -35,11 +26,13 @@
   set(GUROBI_PLUGIN ON)
 endif()
 
-# Export compile commands (useful when working with visual studio code)
-set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+# CMake options default value
+option(CMAKE_POSITION_INDEPENDENT_CODE "Default value for POSITION_INDEPENDENT_CODE of targets" TRUE)
 
 # -------------------------------------------------------------------------------------------------------------------
 #  -- CMake initialisation
+
+include(GNUInstallDirs)
 
 # Fix library suffixes for Web Assembly platform
 include(cmake/support/emscripten_setup.cmake)
@@ -109,3 +102,7 @@
 
 include(cmake/support/config_export.cmake)
 include(cmake/support/config_output.cmake)
+
+# -------------------------------------------------------------------------------------------------------------------
+#  -- Support Actions
+include(cmake/support/format.cmake)

=== tests/requirements.txt ===
PyYAML==5.3
pytest==6.*
py==1.9.*
pytest-html==2.*
pytest-xdist==2.*
pytest-instafail==0.4.*
minizinc==0.4.*

=== debian/changelog ===
minizinc (2.5.3+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Kari Pahula <kaol@debian.org>  Wed, 09 Dec 2020 20:02:58 +0200

minizinc (2.5.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Repackaged source to remove documentation licensed under CC BY-ND.

 -- Kari Pahula <kaol@debian.org>  Sun, 15 Nov 2020 16:27:23 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: debhelper (>= 11), dh-exec, cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended, libgecode-dev (>= 6.2.0)
-Standards-Version: 4.4.1
+Build-Depends: debhelper (>= 13), dh-exec, cmake, flex, bison, flatzinc, latexmk, texlive-latex-recommended, libgecode-dev (>= 6.2.0)
+Standards-Version: 4.5.0
 Homepage: http://www.minizinc.org/
 
 Package: minizinc

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_GECODE=ON

override_dh_install:
	dh_install
	rm -rf $(CURDIR)/debian/minizinc/usr/lib $(CURDIR)/debian/minizinc/usr/include

override_dh_installdocs:
	dh_installdocs
	rm -f $(CURDIR)/debian/minizinc/usr/share/doc/minizinc/*.txt
